filter {
    if [@metadata][beat] == "journalbeat" and ("internal_input" in [tags]) {
        if [systemd][unit] == "fail2ban.service" {
            grok {
                patterns_dir   => "/usr/share/logstash/pipeline-main/patterns.d"
                match => { "message" => "%{FAIL2BAN}" }
            }
            if [fail2ban_source_ip] {
                # disabled due to OSS licence conflict, solution proposed: move to fluentd
                # geoip {
                #     source => "fail2ban_source_ip"
                #     target => "fail2ban_bgp"
                # }
                mutate {
                    add_field => { "fail2ban_source_hostname" => "%{fail2ban_source_ip}" }
                }
                dns {
                    reverse => [ "fail2ban_source_hostname" ]
                    action => "replace"
                    hit_cache_size => 8000
                    hit_cache_ttl => 300
                    failed_cache_size => 1000
                    failed_cache_ttl => 300
                }
            }
        }
    }
}

